// Generated by gmmproc 2.46.1 -- DO NOT MODIFY!


#include <glibmm.h>

#include <goocanvasmm/widget.h>
#include <goocanvasmm/private/widget_p.h>


/* Copyright (C) 1998-2006 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <goocanvaswidget.h>

namespace Goocanvas
{


Widget::Widget(Gtk::Widget& widget, double x, double y, double width, double height)
: 
  // Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Goocanvas::ItemSimple(Glib::ConstructParams(widget_class_.init(), "widget",widget.gobj(),"x",x,"y",y,"width",width,"height",height, static_cast<char*>(0)))
{
}

} //namespace Goocanvas

namespace
{
} // anonymous namespace


namespace Glib
{

Glib::RefPtr<Goocanvas::Widget> wrap(GooCanvasWidget* object, bool take_copy)
{
  return Glib::RefPtr<Goocanvas::Widget>( dynamic_cast<Goocanvas::Widget*> (Glib::wrap_auto ((GObject*)(object), take_copy)) );
  //We use dynamic_cast<> in case of multiple inheritance.
}

} /* namespace Glib */


namespace Goocanvas
{


/* The *_Class implementation: */

const Glib::Class& Widget_Class::init()
{
  if(!gtype_) // create the GType if necessary
  {
    // Glib::Class has to know the class init function to clone custom types.
    class_init_func_ = &Widget_Class::class_init_function;

    // This is actually just optimized away, apparently with no harm.
    // Make sure that the parent type has been created.
    //CppClassParent::CppObjectType::get_type();

    // Create the wrapper type, with the same class/instance size as the base type.
    register_derived_type(goo_canvas_widget_get_type());

    // Add derived versions of interfaces, if the C type implements any interfaces:

  }

  return *this;
}


void Widget_Class::class_init_function(void* g_class, void* class_data)
{
  const auto klass = static_cast<BaseClassType*>(g_class);
  CppClassParent::class_init_function(klass, class_data);


}


Glib::ObjectBase* Widget_Class::wrap_new(GObject* object)
{
  return new Widget((GooCanvasWidget*)object);
}


/* The implementation: */

GooCanvasWidget* Widget::gobj_copy()
{
  reference();
  return gobj();
}

Widget::Widget(const Glib::ConstructParams& construct_params)
:
  Goocanvas::ItemSimple(construct_params)
{

}

Widget::Widget(GooCanvasWidget* castitem)
:
  Goocanvas::ItemSimple((GooCanvasItemSimple*)(castitem))
{}


Widget::Widget(Widget&& src) noexcept
: Goocanvas::ItemSimple(std::move(src))
{}

Widget& Widget::operator=(Widget&& src) noexcept
{
  Goocanvas::ItemSimple::operator=(std::move(src));
  return *this;
}

Widget::~Widget() noexcept
{}


Widget::CppClassType Widget::widget_class_; // initialize static member

GType Widget::get_type()
{
  return widget_class_.init().get_type();
}


GType Widget::get_base_type()
{
  return goo_canvas_widget_get_type();
}


Glib::RefPtr<Widget> Widget::create(Gtk::Widget& widget, double x, double y, double width, double height)
{
  return Glib::RefPtr<Widget>( new Widget(widget, x, y, width, height) );
}


Glib::PropertyProxy< Gtk::Widget* > Widget::property_widget() 
{
  return Glib::PropertyProxy< Gtk::Widget* >(this, "widget");
}

Glib::PropertyProxy_ReadOnly< Gtk::Widget* > Widget::property_widget() const
{
  return Glib::PropertyProxy_ReadOnly< Gtk::Widget* >(this, "widget");
}

Glib::PropertyProxy< AnchorType > Widget::property_anchor() 
{
  return Glib::PropertyProxy< AnchorType >(this, "anchor");
}

Glib::PropertyProxy_ReadOnly< AnchorType > Widget::property_anchor() const
{
  return Glib::PropertyProxy_ReadOnly< AnchorType >(this, "anchor");
}


} // namespace Goocanvas


